---
title: Online Course Registration Form
product: PDF Generator
description: Get a printable online course registration form in PDF. Create editable or prefilled course enrollment forms using SurveyJS PDF Generator.
framework: Vanilla JS
source: https://surveyjs.io/pdf-generator/examples/pdf-education-online-course-registration-form-template/vanillajs
index: https://surveyjs.io/pdf-generator/examples/overview.md
---

# Online Course Registration Form (Vanilla JS)

## Files

### `public/index.html`

```html
<div style="display: flex;">
    <div id="surveyElement" style="flex: 1 1 0%; height: 100%; min-width: 0;"></div>
    <div id="pdf-preview" style="flex: 0.7 0.7 0%; display: none">
        <embed id="pdf-preview-frame" type="application/pdf" style="width:100%; height:100%;" />
    </div>
</div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import { SurveyPDF } from "survey-pdf";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function createSurveyPdfModel (surveyModel) {
    const surveyPDF = new SurveyPDF(json);
    if (surveyModel) {
        surveyPDF.data = surveyModel.data;
        surveyPDF.locale = surveyModel.locale;
        
        
    }
    
    return surveyPDF;
}
function saveSurveyToPdf (filename, surveyModel) {
    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.save(filename);
}

const previewDiv = document.getElementById("pdf-preview");
const previewEmbed = document.getElementById("pdf-preview-frame");
let pdfBlobUrl;

function showPdfPreview(surveyModel) {
    if (!previewDiv || !previewEmbed) return;

    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.raw("blob").then((blob) => {
        if (pdfBlobUrl) {
            URL.revokeObjectURL(pdfBlobUrl);
        }
        pdfBlobUrl = URL.createObjectURL(blob);
        previewEmbed.setAttribute("src", pdfBlobUrl);
        previewDiv.style.display = "block";
    });
}

function previewPdf(surveyModel) {
    if (!previewDiv) return;

    if (previewDiv.style.display !== "none") {
        previewDiv.style.display = "none";
        return;
    }

    showPdfPreview(surveyModel);
}

const survey = new Model(json);
survey.showCompleteButton = false;
survey.navigationButtonsLocation = "topBottom";
survey.addNavigationItem({
    id: "survey_save_as_file",
    title: "Download PDF",
    action: () => {
        saveSurveyToPdf("surveyResult.pdf", survey);
    }
});
survey.addNavigationItem({
    id: "survey_pdf_preview",
    title: "Preview PDF",
    visible: window.navigator.pdfViewerEnabled,
    action: () => {
        previewPdf(survey);
    }
});
survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "title": "Online Course Registration Form",
  "pages": [
    {
      "name": "terms-conditions",
      "elements": [
        {
          "type": "panel",
          "name": "important-info-panel",
          "elements": [
            {
              "type": "html",
              "name": "intro",
              "html": "<p><strong>Payment Disclosures and Terms</strong></p><p>I understand that I am responsible for all charges related to this registration at the college.</p><p>I confirm that I have read the policies and procedures described in the student handbook.</p><p>I understand the drop, add, withdrawal, and refund policies described in the handbook.</p><p>I understand that tuition and fees must be paid in full for all classes in which I remain enrolled after the fifth class day of the term.</p><p>I understand that all tuition and fees must be paid no later than the fifth day of the term unless an approved deferment is in effect.</p><p>I understand that late fees may apply.</p><p>I understand that if I have an unpaid balance, further enrollment may be restricted and the balance may be sent to a collection agency. I accept responsibility for any collection costs and fees.</p>"
            }
          ]
        },
        {
          "type": "boolean",
          "name": "terms-confirmation",
          "title": "I confirm that I have read and understand the terms above.",
          "displayMode": "checkbox"
        }
      ]
    },
    {
      "name": "details",
      "title": "Personal Information",
      "elements": [
        {
          "type": "radiogroup",
          "name": "term",
          "title": "Term",
          "isRequired": true,
          "choices": [
            "Fall",
            "Winter",
            "Spring",
            "May",
            "Summer"
          ],
          "colCount": 2
        },
        {
          "type": "text",
          "name": "dob",
          "title": "Date of birth (you must be at least 16 years old to register)",
          "isRequired": true,
          "validators": [
            {
              "type": "expression",
              "text": "You must be at least 16 years old to register for courses.",
              "expression": "age({dob}) > 16"
            }
          ],
          "inputType": "date"
        },
        {
          "type": "text",
          "name": "ssn",
          "title": "Last 4 digits of Social Security Number",
          "description": "Enter the last four digits to help prevent duplicate student records.",
          "descriptionLocation": "underInput",
          "isRequired": true,
          "startWithNewLine": false,
          "maskType": "pattern",
          "maskSettings": {
            "pattern": "9999"
          }
        }
      ]
    },
    {
      "name": "ethnicity-race",
      "elements": [
        {
          "type": "radiogroup",
          "name": "ethnicity",
          "title": "Ethnicity",
          "choices": [
            {
              "value": "hispanic",
              "text": "Hispanic"
            },
            {
              "value": "latino",
              "text": "Latino"
            }
          ],
          "showOtherItem": true,
          "otherText": "Other"
        },
        {
          "type": "radiogroup",
          "name": "race",
          "title": "Race",
          "choices": [
            "American Indian or Alaska Native",
            "Black or African American",
            "Native Hawaiian or Other Pacific Islander",
            "Asian",
            "White"
          ],
          "colCount": 2
        }
      ]
    },
    {
      "name": "contact-info",
      "title": "Contact Information",
      "elements": [
        {
          "type": "text",
          "name": "first-name",
          "title": "First name"
        },
        {
          "type": "text",
          "name": "last-name",
          "startWithNewLine": false,
          "title": "Last name"
        },
        {
          "type": "text",
          "name": "address",
          "title": "Street address"
        },
        {
          "type": "text",
          "name": "city",
          "title": "City"
        },
        {
          "type": "text",
          "name": "zip-code",
          "startWithNewLine": false,
          "title": "ZIP code",
          "inputType": "number",
          "autocomplete": "postal-code",
          "maskType": "pattern",
          "maskSettings": {
            "pattern": "999999"
          }
        },
        {
          "type": "text",
          "name": "phone",
          "title": "Phone number with area code",
          "maskType": "pattern",
          "maskSettings": {
            "pattern": "+1(999)-999-99-99"
          }
        },
        {
          "type": "text",
          "name": "email",
          "startWithNewLine": false,
          "title": "Email address",
          "autocomplete": "email"
        }
      ]
    },
    {
      "name": "residency",
      "title": "Residency",
      "elements": [
        {
          "type": "radiogroup",
          "name": "resident",
          "title": "Are you a resident of the United States?",
          "choices": [
            "Yes",
            "No"
          ]
        },
        {
          "type": "text",
          "name": "since-date",
          "startWithNewLine": false,
          "title": "If yes, enter the date when your U.S. residency began",
          "inputType": "date"
        },
        {
          "type": "text",
          "name": "how-long",
          "title": "Duration of U.S. residency"
        },
        {
          "type": "text",
          "name": "country-residency",
          "title": "Country of residency (if you are not a U.S. resident)",
          "description": "List all countries that apply."
        },
        {
          "type": "radiogroup",
          "name": "citizenship",
          "title": "Do you have U.S. citizenship?",
          "choices": [
            "Yes",
            "No"
          ]
        },
        {
          "type": "radiogroup",
          "name": "status",
          "title": "If you do not have U.S. citizenship, indicate your status if applicable",
          "choices": [
            "Resident alien",
            "Refugee or asylee",
            "Temporary protected status",
            "None of these"
          ]
        },
        {
          "type": "radiogroup",
          "name": "visa",
          "title": "Do you have or intend to apply for a visa, if applicable?",
          "choices": [
            "Yes",
            "No"
          ]
        },
        {
          "type": "html",
          "name": "comment",
          "html": "If you intend to apply for a visa, contact the international student office to determine whether a separate application is required."
        }
      ]
    },
    {
      "name": "courses",
      "elements": [
        {
          "type": "paneldynamic",
          "name": "courses",
          "title": "Courses to register for",
          "description": "Specify the courses you want to register for. You must register for at least three courses and no more than six.",
          "panelCount": 6,
          "minPanelCount": 3,
          "maxPanelCount": 6,
          "panelsState": "firstExpanded",
          "templateTitle": "Course {panelIndex}",
          "templateElements": [
            {
              "type": "text",
              "name": "id",
              "title": "Course ID",
              "isRequired": true
            },
            {
              "type": "text",
              "name": "subject",
              "startWithNewLine": false,
              "title": "Subject and number"
            },
            {
              "type": "text",
              "name": "title",
              "title": "Course title",
              "isRequired": true
            },
            {
              "type": "text",
              "name": "credits",
              "startWithNewLine": false,
              "title": "Credits"
            }
          ],
          "addPanelText": "Add another course"
        }
      ]
    },
    {
      "name": "signature",
      "elements": [
        {
          "type": "signaturepad",
          "name": "signature",
          "title": "Signature",
          "signatureHeight": 100
        },
        {
          "type": "text",
          "name": "date",
          "startWithNewLine": false,
          "title": "Date",
          "inputType": "date"
        }
      ]
    }
  ],
  "calculatedValues": [
    {
      "name": "residency-years",
      "expression": "dateDiff({since-date}, today(), 'years')"
    },
    {
      "name": "residency-months",
      "expression": "dateDiff({since-date}, today(), 'months') % 12"
    }
  ],
  "checkErrorsMode": "onValueChanged",
  "headerView": "advanced",
  "questionsOnPageMode": "singlePage"
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest",
    "survey-pdf": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/pdf-generator/examples/pdf-education-online-course-registration-form-template/angular.md)
- [React](https://surveyjs.io/pdf-generator/examples/pdf-education-online-course-registration-form-template/reactjs.md)
- [Vue 3](https://surveyjs.io/pdf-generator/examples/pdf-education-online-course-registration-form-template/vue3js.md)
- [jQuery](https://surveyjs.io/pdf-generator/examples/pdf-education-online-course-registration-form-template/jquery.md)


---
title: Online Course Registration Form
product: PDF Generator
description: Get a printable online course registration form in PDF. Create editable or prefilled course enrollment forms using SurveyJS PDF Generator.
framework: React
source: https://surveyjs.io/pdf-generator/examples/pdf-education-online-course-registration-form-template/reactjs
index: https://surveyjs.io/pdf-generator/examples/overview.md
---

# Online Course Registration Form (React)

## Files

### `public/index.html`

```html
<div style="display: flex;">
    <div id="surveyElement" style="flex: 1 1 0%; height: 100%; min-width: 0;"></div>
    <div id="pdf-preview" style="flex: 0.7 0.7 0%; display: none">
        <embed id="pdf-preview-frame" type="application/pdf" style="width:100%; height:100%;" />
    </div>
</div>
```

### `src/SurveyPdfComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { SurveyPDF } from "survey-pdf";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function createSurveyPdfModel (surveyModel) {
    const surveyPDF = new SurveyPDF(json);
    if (surveyModel) {
        surveyPDF.data = surveyModel.data;
        surveyPDF.locale = surveyModel.locale;
        
        
    }
    
    return surveyPDF;
}
function saveSurveyToPdf (filename, surveyModel) {
    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.save(filename);
}

const previewDiv = document.getElementById("pdf-preview");
const previewEmbed = document.getElementById("pdf-preview-frame");
let pdfBlobUrl;

function showPdfPreview(surveyModel) {
    if (!previewDiv || !previewEmbed) return;

    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.raw("blob").then((blob) => {
        if (pdfBlobUrl) {
            URL.revokeObjectURL(pdfBlobUrl);
        }
        pdfBlobUrl = URL.createObjectURL(blob);
        previewEmbed.setAttribute("src", pdfBlobUrl);
        previewDiv.style.display = "block";
    });
}

function previewPdf(surveyModel) {
    if (!previewDiv) return;

    if (previewDiv.style.display !== "none") {
        previewDiv.style.display = "none";
        return;
    }

    showPdfPreview(surveyModel);
}

function SurveyPdfComponent () {
    const survey = new Model(json);
    survey.showCompleteButton = false;
    survey.navigationButtonsLocation = "topBottom";
    survey.addNavigationItem({
        id: "survey_save_as_file",
        title: "Download PDF",
        action: () => {
            saveSurveyToPdf("surveyResult.pdf", survey);
        }
    });
    survey.addNavigationItem({
        id: "survey_pdf_preview",
        title: "Preview PDF",
        visible: window.navigator.pdfViewerEnabled,
        action: () => {
            previewPdf(survey);
        }
    });
    return (<Survey model={survey} />);
}

export default SurveyPdfComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyPdfComponent from "./SurveyPdfComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyPdfComponent />);
```

### `src/json.js`

```js
export const json = {
  "title": "Online Course Registration Form",
  "pages": [
    {
      "name": "terms-conditions",
      "elements": [
        {
          "type": "panel",
          "name": "important-info-panel",
          "elements": [
            {
              "type": "html",
              "name": "intro",
              "html": "<p><strong>Payment Disclosures and Terms</strong></p><p>I understand that I am responsible for all charges related to this registration at the college.</p><p>I confirm that I have read the policies and procedures described in the student handbook.</p><p>I understand the drop, add, withdrawal, and refund policies described in the handbook.</p><p>I understand that tuition and fees must be paid in full for all classes in which I remain enrolled after the fifth class day of the term.</p><p>I understand that all tuition and fees must be paid no later than the fifth day of the term unless an approved deferment is in effect.</p><p>I understand that late fees may apply.</p><p>I understand that if I have an unpaid balance, further enrollment may be restricted and the balance may be sent to a collection agency. I accept responsibility for any collection costs and fees.</p>"
            }
          ]
        },
        {
          "type": "boolean",
          "name": "terms-confirmation",
          "title": "I confirm that I have read and understand the terms above.",
          "displayMode": "checkbox"
        }
      ]
    },
    {
      "name": "details",
      "title": "Personal Information",
      "elements": [
        {
          "type": "radiogroup",
          "name": "term",
          "title": "Term",
          "isRequired": true,
          "choices": [
            "Fall",
            "Winter",
            "Spring",
            "May",
            "Summer"
          ],
          "colCount": 2
        },
        {
          "type": "text",
          "name": "dob",
          "title": "Date of birth (you must be at least 16 years old to register)",
          "isRequired": true,
          "validators": [
            {
              "type": "expression",
              "text": "You must be at least 16 years old to register for courses.",
              "expression": "age({dob}) > 16"
            }
          ],
          "inputType": "date"
        },
        {
          "type": "text",
          "name": "ssn",
          "title": "Last 4 digits of Social Security Number",
          "description": "Enter the last four digits to help prevent duplicate student records.",
          "descriptionLocation": "underInput",
          "isRequired": true,
          "startWithNewLine": false,
          "maskType": "pattern",
          "maskSettings": {
            "pattern": "9999"
          }
        }
      ]
    },
    {
      "name": "ethnicity-race",
      "elements": [
        {
          "type": "radiogroup",
          "name": "ethnicity",
          "title": "Ethnicity",
          "choices": [
            {
              "value": "hispanic",
              "text": "Hispanic"
            },
            {
              "value": "latino",
              "text": "Latino"
            }
          ],
          "showOtherItem": true,
          "otherText": "Other"
        },
        {
          "type": "radiogroup",
          "name": "race",
          "title": "Race",
          "choices": [
            "American Indian or Alaska Native",
            "Black or African American",
            "Native Hawaiian or Other Pacific Islander",
            "Asian",
            "White"
          ],
          "colCount": 2
        }
      ]
    },
    {
      "name": "contact-info",
      "title": "Contact Information",
      "elements": [
        {
          "type": "text",
          "name": "first-name",
          "title": "First name"
        },
        {
          "type": "text",
          "name": "last-name",
          "startWithNewLine": false,
          "title": "Last name"
        },
        {
          "type": "text",
          "name": "address",
          "title": "Street address"
        },
        {
          "type": "text",
          "name": "city",
          "title": "City"
        },
        {
          "type": "text",
          "name": "zip-code",
          "startWithNewLine": false,
          "title": "ZIP code",
          "inputType": "number",
          "autocomplete": "postal-code",
          "maskType": "pattern",
          "maskSettings": {
            "pattern": "999999"
          }
        },
        {
          "type": "text",
          "name": "phone",
          "title": "Phone number with area code",
          "maskType": "pattern",
          "maskSettings": {
            "pattern": "+1(999)-999-99-99"
          }
        },
        {
          "type": "text",
          "name": "email",
          "startWithNewLine": false,
          "title": "Email address",
          "autocomplete": "email"
        }
      ]
    },
    {
      "name": "residency",
      "title": "Residency",
      "elements": [
        {
          "type": "radiogroup",
          "name": "resident",
          "title": "Are you a resident of the United States?",
          "choices": [
            "Yes",
            "No"
          ]
        },
        {
          "type": "text",
          "name": "since-date",
          "startWithNewLine": false,
          "title": "If yes, enter the date when your U.S. residency began",
          "inputType": "date"
        },
        {
          "type": "text",
          "name": "how-long",
          "title": "Duration of U.S. residency"
        },
        {
          "type": "text",
          "name": "country-residency",
          "title": "Country of residency (if you are not a U.S. resident)",
          "description": "List all countries that apply."
        },
        {
          "type": "radiogroup",
          "name": "citizenship",
          "title": "Do you have U.S. citizenship?",
          "choices": [
            "Yes",
            "No"
          ]
        },
        {
          "type": "radiogroup",
          "name": "status",
          "title": "If you do not have U.S. citizenship, indicate your status if applicable",
          "choices": [
            "Resident alien",
            "Refugee or asylee",
            "Temporary protected status",
            "None of these"
          ]
        },
        {
          "type": "radiogroup",
          "name": "visa",
          "title": "Do you have or intend to apply for a visa, if applicable?",
          "choices": [
            "Yes",
            "No"
          ]
        },
        {
          "type": "html",
          "name": "comment",
          "html": "If you intend to apply for a visa, contact the international student office to determine whether a separate application is required."
        }
      ]
    },
    {
      "name": "courses",
      "elements": [
        {
          "type": "paneldynamic",
          "name": "courses",
          "title": "Courses to register for",
          "description": "Specify the courses you want to register for. You must register for at least three courses and no more than six.",
          "panelCount": 6,
          "minPanelCount": 3,
          "maxPanelCount": 6,
          "panelsState": "firstExpanded",
          "templateTitle": "Course {panelIndex}",
          "templateElements": [
            {
              "type": "text",
              "name": "id",
              "title": "Course ID",
              "isRequired": true
            },
            {
              "type": "text",
              "name": "subject",
              "startWithNewLine": false,
              "title": "Subject and number"
            },
            {
              "type": "text",
              "name": "title",
              "title": "Course title",
              "isRequired": true
            },
            {
              "type": "text",
              "name": "credits",
              "startWithNewLine": false,
              "title": "Credits"
            }
          ],
          "addPanelText": "Add another course"
        }
      ]
    },
    {
      "name": "signature",
      "elements": [
        {
          "type": "signaturepad",
          "name": "signature",
          "title": "Signature",
          "signatureHeight": 100
        },
        {
          "type": "text",
          "name": "date",
          "startWithNewLine": false,
          "title": "Date",
          "inputType": "date"
        }
      ]
    }
  ],
  "calculatedValues": [
    {
      "name": "residency-years",
      "expression": "dateDiff({since-date}, today(), 'years')"
    },
    {
      "name": "residency-months",
      "expression": "dateDiff({since-date}, today(), 'months') % 12"
    }
  ],
  "checkErrorsMode": "onValueChanged",
  "headerView": "advanced",
  "questionsOnPageMode": "singlePage"
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest",
    "survey-pdf": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/pdf-generator/examples/pdf-education-online-course-registration-form-template/angular.md)
- [Vue 3](https://surveyjs.io/pdf-generator/examples/pdf-education-online-course-registration-form-template/vue3js.md)
- [jQuery](https://surveyjs.io/pdf-generator/examples/pdf-education-online-course-registration-form-template/jquery.md)
- [Vanilla JS](https://surveyjs.io/pdf-generator/examples/pdf-education-online-course-registration-form-template/vanillajs.md)


---
title: Online Course Registration Form
product: PDF Generator
description: Get a printable online course registration form in PDF. Create editable or prefilled course enrollment forms using SurveyJS PDF Generator.
framework: Angular
source: https://surveyjs.io/pdf-generator/examples/pdf-education-online-course-registration-form-template/angular
index: https://surveyjs.io/pdf-generator/examples/overview.md
---

# Online Course Registration Form (Angular)

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "title": "Online Course Registration Form",
  "pages": [
    {
      "name": "terms-conditions",
      "elements": [
        {
          "type": "panel",
          "name": "important-info-panel",
          "elements": [
            {
              "type": "html",
              "name": "intro",
              "html": "<p><strong>Payment Disclosures and Terms</strong></p><p>I understand that I am responsible for all charges related to this registration at the college.</p><p>I confirm that I have read the policies and procedures described in the student handbook.</p><p>I understand the drop, add, withdrawal, and refund policies described in the handbook.</p><p>I understand that tuition and fees must be paid in full for all classes in which I remain enrolled after the fifth class day of the term.</p><p>I understand that all tuition and fees must be paid no later than the fifth day of the term unless an approved deferment is in effect.</p><p>I understand that late fees may apply.</p><p>I understand that if I have an unpaid balance, further enrollment may be restricted and the balance may be sent to a collection agency. I accept responsibility for any collection costs and fees.</p>"
            }
          ]
        },
        {
          "type": "boolean",
          "name": "terms-confirmation",
          "title": "I confirm that I have read and understand the terms above.",
          "displayMode": "checkbox"
        }
      ]
    },
    {
      "name": "details",
      "title": "Personal Information",
      "elements": [
        {
          "type": "radiogroup",
          "name": "term",
          "title": "Term",
          "isRequired": true,
          "choices": [
            "Fall",
            "Winter",
            "Spring",
            "May",
            "Summer"
          ],
          "colCount": 2
        },
        {
          "type": "text",
          "name": "dob",
          "title": "Date of birth (you must be at least 16 years old to register)",
          "isRequired": true,
          "validators": [
            {
              "type": "expression",
              "text": "You must be at least 16 years old to register for courses.",
              "expression": "age({dob}) > 16"
            }
          ],
          "inputType": "date"
        },
        {
          "type": "text",
          "name": "ssn",
          "title": "Last 4 digits of Social Security Number",
          "description": "Enter the last four digits to help prevent duplicate student records.",
          "descriptionLocation": "underInput",
          "isRequired": true,
          "startWithNewLine": false,
          "maskType": "pattern",
          "maskSettings": {
            "pattern": "9999"
          }
        }
      ]
    },
    {
      "name": "ethnicity-race",
      "elements": [
        {
          "type": "radiogroup",
          "name": "ethnicity",
          "title": "Ethnicity",
          "choices": [
            {
              "value": "hispanic",
              "text": "Hispanic"
            },
            {
              "value": "latino",
              "text": "Latino"
            }
          ],
          "showOtherItem": true,
          "otherText": "Other"
        },
        {
          "type": "radiogroup",
          "name": "race",
          "title": "Race",
          "choices": [
            "American Indian or Alaska Native",
            "Black or African American",
            "Native Hawaiian or Other Pacific Islander",
            "Asian",
            "White"
          ],
          "colCount": 2
        }
      ]
    },
    {
      "name": "contact-info",
      "title": "Contact Information",
      "elements": [
        {
          "type": "text",
          "name": "first-name",
          "title": "First name"
        },
        {
          "type": "text",
          "name": "last-name",
          "startWithNewLine": false,
          "title": "Last name"
        },
        {
          "type": "text",
          "name": "address",
          "title": "Street address"
        },
        {
          "type": "text",
          "name": "city",
          "title": "City"
        },
        {
          "type": "text",
          "name": "zip-code",
          "startWithNewLine": false,
          "title": "ZIP code",
          "inputType": "number",
          "autocomplete": "postal-code",
          "maskType": "pattern",
          "maskSettings": {
            "pattern": "999999"
          }
        },
        {
          "type": "text",
          "name": "phone",
          "title": "Phone number with area code",
          "maskType": "pattern",
          "maskSettings": {
            "pattern": "+1(999)-999-99-99"
          }
        },
        {
          "type": "text",
          "name": "email",
          "startWithNewLine": false,
          "title": "Email address",
          "autocomplete": "email"
        }
      ]
    },
    {
      "name": "residency",
      "title": "Residency",
      "elements": [
        {
          "type": "radiogroup",
          "name": "resident",
          "title": "Are you a resident of the United States?",
          "choices": [
            "Yes",
            "No"
          ]
        },
        {
          "type": "text",
          "name": "since-date",
          "startWithNewLine": false,
          "title": "If yes, enter the date when your U.S. residency began",
          "inputType": "date"
        },
        {
          "type": "text",
          "name": "how-long",
          "title": "Duration of U.S. residency"
        },
        {
          "type": "text",
          "name": "country-residency",
          "title": "Country of residency (if you are not a U.S. resident)",
          "description": "List all countries that apply."
        },
        {
          "type": "radiogroup",
          "name": "citizenship",
          "title": "Do you have U.S. citizenship?",
          "choices": [
            "Yes",
            "No"
          ]
        },
        {
          "type": "radiogroup",
          "name": "status",
          "title": "If you do not have U.S. citizenship, indicate your status if applicable",
          "choices": [
            "Resident alien",
            "Refugee or asylee",
            "Temporary protected status",
            "None of these"
          ]
        },
        {
          "type": "radiogroup",
          "name": "visa",
          "title": "Do you have or intend to apply for a visa, if applicable?",
          "choices": [
            "Yes",
            "No"
          ]
        },
        {
          "type": "html",
          "name": "comment",
          "html": "If you intend to apply for a visa, contact the international student office to determine whether a separate application is required."
        }
      ]
    },
    {
      "name": "courses",
      "elements": [
        {
          "type": "paneldynamic",
          "name": "courses",
          "title": "Courses to register for",
          "description": "Specify the courses you want to register for. You must register for at least three courses and no more than six.",
          "panelCount": 6,
          "minPanelCount": 3,
          "maxPanelCount": 6,
          "panelsState": "firstExpanded",
          "templateTitle": "Course {panelIndex}",
          "templateElements": [
            {
              "type": "text",
              "name": "id",
              "title": "Course ID",
              "isRequired": true
            },
            {
              "type": "text",
              "name": "subject",
              "startWithNewLine": false,
              "title": "Subject and number"
            },
            {
              "type": "text",
              "name": "title",
              "title": "Course title",
              "isRequired": true
            },
            {
              "type": "text",
              "name": "credits",
              "startWithNewLine": false,
              "title": "Credits"
            }
          ],
          "addPanelText": "Add another course"
        }
      ]
    },
    {
      "name": "signature",
      "elements": [
        {
          "type": "signaturepad",
          "name": "signature",
          "title": "Signature",
          "signatureHeight": 100
        },
        {
          "type": "text",
          "name": "date",
          "startWithNewLine": false,
          "title": "Date",
          "inputType": "date"
        }
      ]
    }
  ],
  "calculatedValues": [
    {
      "name": "residency-years",
      "expression": "dateDiff({since-date}, today(), 'years')"
    },
    {
      "name": "residency-months",
      "expression": "dateDiff({since-date}, today(), 'months') % 12"
    }
  ],
  "checkErrorsMode": "onValueChanged",
  "headerView": "advanced",
  "questionsOnPageMode": "singlePage"
};
```

### `src/app/components/pdf.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/pdf.component.html`

```html
<survey [model]="model"></survey>
```

### `src/app/components/pdf.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { SurveyPDF } from "survey-pdf";
import { json } from "./json";
import "./pdf.component.css";
import "survey-core/survey-core.min.css";

function createSurveyPdfModel (surveyModel) {
    const surveyPDF = new SurveyPDF(json);
    if (surveyModel) {
        surveyPDF.data = surveyModel.data;
        surveyPDF.locale = surveyModel.locale;
        
        
    }
    
    return surveyPDF;
}
function saveSurveyToPdf (filename, surveyModel) {
    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.save(filename);
}

const previewDiv = document.getElementById("pdf-preview");
const previewEmbed = document.getElementById("pdf-preview-frame");
let pdfBlobUrl;

function showPdfPreview(surveyModel) {
    if (!previewDiv || !previewEmbed) return;

    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.raw("blob").then((blob) => {
        if (pdfBlobUrl) {
            URL.revokeObjectURL(pdfBlobUrl);
        }
        pdfBlobUrl = URL.createObjectURL(blob);
        previewEmbed.setAttribute("src", pdfBlobUrl);
        previewDiv.style.display = "block";
    });
}

function previewPdf(surveyModel) {
    if (!previewDiv) return;

    if (previewDiv.style.display !== "none") {
        previewDiv.style.display = "none";
        return;
    }

    showPdfPreview(surveyModel);
}

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./pdf.component.html",
    styleUrls: ["./pdf.component.css"]
})
export class SurveyPdfComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.showCompleteButton = false;
        survey.navigationButtonsLocation = "topBottom";
        survey.addNavigationItem({
            id: "survey_save_as_file",
            title: "Download PDF",
            action: () => {
                saveSurveyToPdf("surveyResult.pdf", survey);
            }
        });
        survey.addNavigationItem({
            id: "survey_pdf_preview",
            title: "Preview PDF",
            visible: window.navigator.pdfViewerEnabled,
            action: () => {
                previewPdf(survey);
            }
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyPdfComponent } from "./components/pdf.component";

@NgModule({
    declarations: [AppComponent, SurveyPdfComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<div style="display: flex;">
    <div id="surveyElement" style="flex: 1 1 0%; height: 100%; min-width: 0;">
        <app-root></app-root>
    </div>
    <div id="pdf-preview" style="flex: 0.7 0.7 0%; display: none">
        <embed id="pdf-preview-frame" type="application/pdf" style="width:100%; height:100%;" />
    </div>
</div>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css

```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "survey-pdf": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/pdf-generator/examples/pdf-education-online-course-registration-form-template/reactjs.md)
- [Vue 3](https://surveyjs.io/pdf-generator/examples/pdf-education-online-course-registration-form-template/vue3js.md)
- [jQuery](https://surveyjs.io/pdf-generator/examples/pdf-education-online-course-registration-form-template/jquery.md)
- [Vanilla JS](https://surveyjs.io/pdf-generator/examples/pdf-education-online-course-registration-form-template/vanillajs.md)
